#include <xc.h>
#include "config_sys.h"

void sys_int(void){
  TRISA0 = 0;           // LED out
  ANSA5  = 0;           // PWM5 RA5 デジタル
  RA5PPS = 2;           // PWM5をRA5に出力
    //------------ Initialize PWM -----------------------
    // Timer2 は、Fosc/4(8MHz)をPreScalerで 1/1(8MHz)
    // 8bitで255カウントする　　　　　8M / 255 = 31KHz
    // PostScaler 1/4 でTMR2IFは7.8KHz周期で「1」になる 
    // ---------------------------------------------------
    T2CON  = 0b00011100;   // Timer 2 Post 1/4 Pre 1/1設定
    PR2    = 0xFF;         // Timer2 Period Register設定
    // --------------------------------------------
    // PWM5は、TMR2と連携し、
    // 初期値デュティサイクルは、50%
    // --------------------------------------------
    PWM5CON= 0b11000000;                // 正論理出力
    PWM5DCH= 0x80;                      // デュティサイクルを設定
//    PWMTMRS= 0b00000101;                // TMR2と連携（初期値）
    // ADC ---------------------------------------
    ANSA4  = 1;                 // ANA4(RA4)はアナログ入力に設定
    TRISA4 = 1;
    ADACT  = 0b00000000;        // AD変換はプログラムの命令で開始
    ADCON1 = 0b11100011;        // 右詰め出力, AD変換クロックFosc/64 正基準電圧 FVR
    ADCON0 = 0b00010001;        // アナログ入力 ANA4(RA4),ADC ON
    FVRCON = 0b10000001;
    // Pin Interrupt -----------------------------
    WPUA3  = 1;             // SW(RA3)を弱プルアップ
    INTPPS = 0x03;          // SW(RA3)をPin割込みに指定
    INTEDG = 0;             // 立ち下がりで割込み
    INTF = 0;               // Pin割込みフラッグクリア
    // Timer1 -----------------------------------
    T1CON  = 0b11010101;    // LFINTosc Sync PreS 1/2 4sec
//    T1GCON = 0;             // ゲート機能は使用せず
//    TMR1 = 0;               // Timerクリア
    TMR1IF=1;               // Timer1割込みフラッグクリア
}

void LED_OnOff(void){
  LED = 1;             // LED On
  __delay_ms(100);     // 100m秒待つ
  LED = 0;             // LED Off
}

//void waitSW(void){
//      while (PushSW);                  // SWが押されたら繰り返し
//            __delay_ms(10);             // 10m秒待つ
//      while (!PushSW);                  // SWが離れるのを待つ
//            __delay_ms(10);             // 10m秒待つ  
//}

void delay_ms(char sp){
  while(sp--){
    __delay_ms(1); 
  }
} 
